VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Script-a-sketch"
   ClientHeight    =   4680
   ClientLeft      =   6000
   ClientTop       =   4140
   ClientWidth     =   3915
   LinkTopic       =   "Form1"
   ScaleHeight     =   4680
   ScaleWidth      =   3915
   Begin VB.PictureBox Picture1 
      AutoSize        =   -1  'True
      Height          =   2175
      Left            =   120
      ScaleHeight     =   141
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   181
      TabIndex        =   12
      Top             =   2400
      Width           =   2775
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   3360
      Top             =   3240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton Command5 
      Caption         =   "&Load..."
      Height          =   255
      Left            =   3000
      TabIndex        =   11
      Top             =   2040
      Width           =   855
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Set"
      Height          =   255
      Left            =   3000
      TabIndex        =   5
      Top             =   1080
      Width           =   855
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Set&"
      Height          =   255
      Left            =   3000
      TabIndex        =   4
      Top             =   600
      Width           =   855
   End
   Begin VB.CommandButton Command2 
      Caption         =   "&Set"
      Height          =   255
      Left            =   3000
      TabIndex        =   1
      Top             =   120
      Width           =   855
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Go"
      Height          =   255
      Left            =   3000
      TabIndex        =   0
      Top             =   1560
      Width           =   855
   End
   Begin VB.Label Label7 
      Caption         =   "Picture:"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   2040
      Width           =   1695
   End
   Begin VB.Label Label6 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   1800
      TabIndex        =   9
      Top             =   1080
      Width           =   1095
   End
   Begin VB.Label Label5 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   1800
      TabIndex        =   8
      Top             =   600
      Width           =   1095
   End
   Begin VB.Label Label4 
      Caption         =   "Lower right corner:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   1080
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Target window:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Upper left corner:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   600
      Width           =   1575
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   1800
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Script-a-Sketch by Sami Kystil, 2002
'
' This code is licensed under the GNU GPL.

Private Declare Function SetCursorPos& Lib "user32" _
(ByVal x As Long, ByVal y As Long)
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As _
Long) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal lpPointY As Integer, _
ByVal lpPointX As Integer) As Integer
Private Declare Function SetCapture Lib "user32" (ByVal hWnd _
As Long) As Long
Private Declare Sub ClientToScreen Lib "user32" _
               (ByVal hWnd As Long, _
                lpPoint As POINTAPI)
Private Declare Sub GetClientRect Lib "user32" _
               (ByVal hWnd As Long, _
                lpRect As RECT)
Private Declare Sub GetCursorPos Lib "user32" (lpPoint As POINTAPI)
Private Declare Function GetKeyState% Lib "user32" (ByVal nVirtKey As Long)

Private Const MOUSEEVENTF_LEFTDOWN = &H2
Private Const MOUSEEVENTF_LEFTUP = &H4
Private Const MOUSEEVENTF_MIDDLEDOWN = &H20
Private Const MOUSEEVENTF_MIDDLEUP = &H40
Private Const MOUSEEVENTF_RIGHTDOWN = &H8
Private Const MOUSEEVENTF_RIGHTUP = &H10
Private Const MOUSEEVENTF_MOVE = &H1
Private Const VK_ESCAPE = &H1B

Private Declare Sub mouse_event Lib "user32" (ByVal dwFlags As Long, ByVal _
dx As Long, ByVal dy As Long, ByVal cButtons As Long, ByVal dwExtraInfo As _
Long)


Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205
Private Const WM_RBUTTONDBLCLK = &H206
Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_MBUTTONDBLCLK = &H209
Private Const WM_MBUTTONDOWN = &H207
Private Const WM_MBUTTONUP = &H208
Private Const WM_MOUSEMOVE = &H200

Private Type POINTAPI
  x As Long
  y As Long
End Type

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Type LongInt
    lng As Long
End Type

Private Type LoHiWord
    lw As Integer
    hw As Integer
End Type

Dim findWindow As Boolean
Dim findUpperLeft As Boolean
Dim findLowerRight As Boolean
Dim targetHWnd As Long
Dim targetRect As RECT





Function SendMouseEvent(hWnd As Long, lMsg As Long, ByVal nX As Integer, ByVal nY As Integer) As Long
        Dim li As LongInt
        Dim lhw As LoHiWord

        lhw.lw = nX
        lhw.hw = nY
        LSet li = lhw

        SendMouseEvent = SendMessage(hWnd, lMsg, 0&, ByVal li.lng)
End Function
Private Sub Command1_Click()

Command1.Enabled = False
Dim x, y, w, h As Long

w = targetRect.Right - targetRect.Left
h = targetRect.Bottom - targetRect.Top
res = 2

For y = targetRect.Top To targetRect.Bottom Step res
    state = 0
    start = targetRect.Left
    For x = targetRect.Left To targetRect.Right Step res
'        If GetKeyState(VK_ESCAPE) And &H1000 Then Exit Sub
        p = GetPixel((x - targetRect.Left) / w, (y - targetRect.Top) / h)
        
        If state <> p Then
            If state <> 0 Then
                SetCursorPos start, y
                mouse_event MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0
                SetCursorPos x, y
                mouse_event MOUSEEVENTF_LEFTUP, 0, 0, 0, 0
            End If
            state = p
            If state <> 0 Then
                start = x
            End If
        End If
    Next
    If state <> 0 Then
        SetCursorPos start, y
        mouse_event MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0
        SetCursorPos x, y
        mouse_event MOUSEEVENTF_LEFTUP, 0, 0, 0, 0
    End If
Next
Command1.Enabled = True
End Sub

Private Sub Command2_Click()
Command2.Enabled = False
SetCapture Form1.hWnd
findWindow = True
End Sub

Private Sub Command3_Click()
findUpperLeft = True
SetCapture Form1.hWnd
Command3.Enabled = False
End Sub

Private Sub Command4_Click()
findLowerRight = True
SetCapture Form1.hWnd
Command4.Enabled = False
End Sub

Private Sub Command5_Click()
CommonDialog1.Filter = "Bitmaps (*.BMP)|*.BMP|All files (*.*)|*.*"
CommonDialog1.FilterIndex = 1
CommonDialog1.ShowOpen

If Len(CommonDialog1.FileName) Then
    Picture1.Picture = LoadPicture(CommonDialog1.FileName)
    Command1.Enabled = True
End If

End Sub

Private Sub Form_Load()
findWindow = False
findUpperLeft = False
findLowerRight = False
Command1.Enabled = False
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
If findWindow = True Then
    Dim p As POINTAPI

    Command2.Enabled = True
    findWindow = False
    findRect = False
    
    GetCursorPos p
   
    targetHWnd = WindowFromPoint(p.y, p.x)
    
    Label1.Caption = targetHWnd
End If

If findUpperLeft Then
    GetCursorPos p
    Command3.Enabled = True
    targetRect.Left = p.x
    targetRect.Top = p.y
    Label5.Caption = Str$(p.x) + "," + Str$(p.y)
    findUpperLeft = False
    SetCapture 0
End If

If findLowerRight Then
    GetCursorPos p
    If p.x > targetRect.Left And p.y > targetRect.Top Then
        targetRect.Right = p.x
        targetRect.Bottom = p.y
        Label6.Caption = Str$(p.x) + "," + Str$(p.y)
        findLowerRight = False
        SetCapture 0
        Command4.Enabled = True
    End If
End If

End Sub

Private Function GetPixel(x As Double, y As Double) As Long
    Dim p As Long
'    Dim r As Long
'    Dim g As Long
'    Dim b As Long
    Dim px, py As Long
    px = x * (Picture1.ScaleWidth - 1)
    py = y * (Picture1.ScaleHeight - 1)
    GetPixel = 16777215 - Picture1.Point(px, py)
 
'    r = p And &HFF
'    g = (p And 65280) \ &H100
'    b = (p And 16711680) \ &H10000
'    GetPixel = ((r + g + b) / 3) / 255
End Function
